# Class StrBuilder

java.lang.Object
org.apache.commons.text.StrBuilder

All Implemented Interfaces:
  `Serializable, Appendable, CharSequence, Supplier<String>, Builder<String>`

@Deprecated public class StrBuilder extends Object implements CharSequence, Appendable, Serializable, Builder<String>
Deprecated.
Deprecated as of 1.3, use `TextStringBuilder` instead. This class will be removed in 2.0.
Builds a string from constituent parts providing a more flexible and powerful API than `StringBuffer` and `StringBuilder`.

The main differences from `StrBuilder` and `StringBuilder` are:

- Not synchronized
- Not final
- Subclasses have direct access to character array
- Additional methods
  - appendWithSeparators - adds an array of values, with a separator
  - appendPadding - adds a length padding characters
  - appendFixedLength - adds a fixed width field to the builder
  - toCharArray/getChars - simpler ways to get a range of the character array
  - delete - delete char or string
  - replace - search and replace for a char or string
  - leftString/rightString/midString - substring without exceptions
  - contains - whether the builder contains a char or string
  - size/clear/isEmpty - collections style API methods
- Views
  - asTokenizer - uses the internal buffer as the source of a StrTokenizer
  - asReader - uses the internal buffer as the source of a Reader
  - asWriter - allows a Writer to write directly to the internal buffer

The aim has been to provide an API that mimics very closely what StringBuffer provides, but with additional methods. It should be noted that some edge cases, with invalid indices or null input, have been altered - see individual methods. The biggest of these changes is that by default, null will not output the text 'null'. This can be controlled by a property, `setNullText(String)`.

Since:
  1.0
See Also:
  - Serialized Form

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `StrBuilder()`
  Deprecated.
  Constructs an empty builder initial capacity 32 characters.
  `StrBuilder(int initialCapacity)`
  Deprecated.
  Constructs an empty builder the specified initial capacity.
  `StrBuilder(String str)`
  Deprecated.
  Constructs a builder from the string, allocating 32 extra characters for growth.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `StrBuilder`
  `append(boolean value)`
  Deprecated.
  Appends a boolean value to the string builder.
  `StrBuilder`
  `append(char ch)`
  Deprecated.
  Appends a char value to the string builder.
  `StrBuilder`
  `append(char[] chars)`
  Deprecated.
  Appends a char array to the string builder.
  `StrBuilder`
  `append(char[] chars, int startIndex, int length)`
  Deprecated.
  Appends a char array to the string builder.
  `StrBuilder`
  `append(double value)`
  Deprecated.
  Appends a double value to the string builder using `String.valueOf`.
  `StrBuilder`
  `append(float value)`
  Deprecated.
  Appends a float value to the string builder using `String.valueOf`.
  `StrBuilder`
  `append(int value)`
  Deprecated.
  Appends an int value to the string builder using `String.valueOf`.
  `StrBuilder`
  `append(long value)`
  Deprecated.
  Appends a long value to the string builder using `String.valueOf`.
  `StrBuilder`
  `append(CharSequence seq)`
  Deprecated.
  Appends a CharSequence to this string builder.
  `StrBuilder`
  `append(CharSequence seq, int startIndex, int length)`
  Deprecated.
  Appends part of a CharSequence to this string builder.
  `StrBuilder`
  `append(Object obj)`
  Deprecated.
  Appends an object to this string builder.
  `StrBuilder`
  `append(String str)`
  Deprecated.
  Appends a string to this string builder.
  `StrBuilder`
  `append(StringBuffer str)`
  Deprecated.
  Appends a string buffer to this string builder.
  `StrBuilder`
  `append(StringBuffer str, int startIndex, int length)`
  Deprecated.
  Appends part of a string buffer to this string builder.
  `StrBuilder`
  `append(StringBuilder str)`
  Deprecated.
  Appends a StringBuilder to this string builder.
  `StrBuilder`
  `append(StringBuilder str, int startIndex, int length)`
  Deprecated.
  Appends part of a StringBuilder to this string builder.
  `StrBuilder`
  `append(String str, int startIndex, int length)`
  Deprecated.
  Appends part of a string to this string builder.
  `StrBuilder`
  `append(String format, Object... objs)`
  Deprecated.
  Calls `String.format(String, Object...)` and appends the result.
  `StrBuilder`
  `append(CharBuffer buf)`
  Deprecated.
  Appends the contents of a char buffer to this string builder.
  `StrBuilder`
  `append(CharBuffer buf, int startIndex, int length)`
  Deprecated.
  Appends the contents of a char buffer to this string builder.
  `StrBuilder`
  `append(StrBuilder str)`
  Deprecated.
  Appends another string builder to this string builder.
  `StrBuilder`
  `append(StrBuilder str, int startIndex, int length)`
  Deprecated.
  Appends part of a string builder to this string builder.
  `StrBuilder`
  `appendAll(Iterable<?> iterable)`
  Deprecated.
  Appends each item in an iterable to the builder without any separators.
  `StrBuilder`
  `appendAll(Iterator<?> it)`
  Deprecated.
  Appends each item in an iterator to the builder without any separators.
  `<T> StrBuilder`
  `appendAll(T... array)`
  Deprecated.
  Appends each item in an array to the builder without any separators.
  `StrBuilder`
  `appendFixedWidthPadLeft(int value, int width, char padChar)`
  Deprecated.
  Appends an object to the builder padding on the left to a fixed width.
  `StrBuilder`
  `appendFixedWidthPadLeft(Object obj, int width, char padChar)`
  Deprecated.
  Appends an object to the builder padding on the left to a fixed width.
  `StrBuilder`
  `appendFixedWidthPadRight(int value, int width, char padChar)`
  Deprecated.
  Appends an object to the builder padding on the right to a fixed length.
  `StrBuilder`
  `appendFixedWidthPadRight(Object obj, int width, char padChar)`
  Deprecated.
  Appends an object to the builder padding on the right to a fixed length.
  `StrBuilder`
  `appendln(boolean value)`
  Deprecated.
  Appends a boolean value followed by a `new line` to the string builder.
  `StrBuilder`
  `appendln(char ch)`
  Deprecated.
  Appends a char value followed by a `new line` to the string builder.
  `StrBuilder`
  `appendln(char[] chars)`
  Deprecated.
  Appends a char array followed by a `new line` to the string builder.
  `StrBuilder`
  `appendln(char[] chars, int startIndex, int length)`
  Deprecated.
  Appends a char array followed by a `new line` to the string builder.
  `StrBuilder`
  `appendln(double value)`
  Deprecated.
  Appends a double value followed by a `new line` to the string builder using `String.valueOf`.
  `StrBuilder`
  `appendln(float value)`
  Deprecated.
  Appends a float value followed by a `new line` to the string builder using `String.valueOf`.
  `StrBuilder`
  `appendln(int value)`
  Deprecated.
  Appends an int value followed by a `new line` to the string builder using `String.valueOf`.
  `StrBuilder`
  `appendln(long value)`
  Deprecated.
  Appends a long value followed by a `new line` to the string builder using `String.valueOf`.
  `StrBuilder`
  `appendln(Object obj)`
  Deprecated.
  Appends an object followed by a `new line` to this string builder.
  `StrBuilder`
  `appendln(String str)`
  Deprecated.
  Appends a string followed by a `new line` to this string builder.
  `StrBuilder`
  `appendln(StringBuffer str)`
  Deprecated.
  Appends a string buffer followed by a `new line` to this string builder.
  `StrBuilder`
  `appendln(StringBuffer str, int startIndex, int length)`
  Deprecated.
  Appends part of a string buffer followed by a `new line` to this string builder.
  `StrBuilder`
  `appendln(StringBuilder str)`
  Deprecated.
  Appends a string builder followed by a `new line` to this string builder.
  `StrBuilder`
  `appendln(StringBuilder str, int startIndex, int length)`
  Deprecated.
  Appends part of a string builder followed by a `new line` to this string builder.
  `StrBuilder`
  `appendln(String str, int startIndex, int length)`
  Deprecated.
  Appends part of a string followed by a `new line` to this string builder.
  `StrBuilder`
  `appendln(String format, Object... objs)`
  Deprecated.
  Calls `String.format(String, Object...)` and appends the result.
  `StrBuilder`
  `appendln(StrBuilder str)`
  Deprecated.
  Appends another string builder followed by a `new line` to this string builder.
  `StrBuilder`
  `appendln(StrBuilder str, int startIndex, int length)`
  Deprecated.
  Appends part of a string builder followed by a `new line` to this string builder.
  `StrBuilder`
  `appendNewLine()`
  Deprecated.
  Appends this builder's new line string to this builder.
  `StrBuilder`
  `appendNull()`
  Deprecated.
  Appends this builder's null text to this builder.
  `StrBuilder`
  `appendPadding(int length, char padChar)`
  Deprecated.
  Appends the pad character to the builder the specified number of times.
  `StrBuilder`
  `appendSeparator(char separator)`
  Deprecated.
  Appends a separator if the builder is currently non-empty.
  `StrBuilder`
  `appendSeparator(char standard, char defaultIfEmpty)`
  Deprecated.
  Appends one of both separators to the builder If the builder is currently empty it will append the defaultIfEmpty-separator Otherwise it will append the standard-separator The separator is appended using `append(char)`.
  `StrBuilder`
  `appendSeparator(char separator, int loopIndex)`
  Deprecated.
  Appends a separator to the builder if the loop index is greater than zero.
  `StrBuilder`
  `appendSeparator(String separator)`
  Deprecated.
  Appends a separator if the builder is currently non-empty.
  `StrBuilder`
  `appendSeparator(String separator, int loopIndex)`
  Deprecated.
  Appends a separator to the builder if the loop index is greater than zero.
  `StrBuilder`
  `appendSeparator(String standard, String defaultIfEmpty)`
  Deprecated.
  Appends one of both separators to the StrBuilder.
  `void`
  `appendTo(Appendable appendable)`
  Deprecated.
  Appends current contents of this `StrBuilder` to the provided `Appendable`.
  `StrBuilder`
  `appendWithSeparators(Iterable<?> iterable, String separator)`
  Deprecated.
  Appends an iterable placing separators between each value, but not before the first or after the last.
  `StrBuilder`
  `appendWithSeparators(Object[] array, String separator)`
  Deprecated.
  Appends an array placing separators between each value, but not before the first or after the last.
  `StrBuilder`
  `appendWithSeparators(Iterator<?> iterator, String separator)`
  Deprecated.
  Appends an iterator placing separators between each value, but not before the first or after the last.
  `Reader`
  `asReader()`
  Deprecated.
  Gets the contents of this builder as a Reader.
  `StrTokenizer`
  `asTokenizer()`
  Deprecated.
  Creates a tokenizer that can tokenize the contents of this builder.
  `Writer`
  `asWriter()`
  Deprecated.
  Gets this builder as a Writer that can be written to.
  `String`
  `build()`
  Deprecated.
  Use `get()`.
  `int`
  `capacity()`
  Deprecated.
  Gets the current size of the internal character array buffer.
  `char`
  `charAt(int index)`
  Deprecated.
  Gets the character at the specified index.
  `StrBuilder`
  `clear()`
  Deprecated.
  Clears the string builder (convenience Collections API style method).
  `boolean`
  `contains(char ch)`
  Deprecated.
  Checks if the string builder contains the specified char.
  `boolean`
  `contains(String str)`
  Deprecated.
  Tests if the string builder contains the specified string.
  `boolean`
  `contains(StrMatcher matcher)`
  Deprecated.
  Tests if the string builder contains a string matched using the specified matcher.
  `StrBuilder`
  `delete(int startIndex, int endIndex)`
  Deprecated.
  Deletes the characters between the two specified indices.
  `StrBuilder`
  `deleteAll(char ch)`
  Deprecated.
  Deletes the character wherever it occurs in the builder.
  `StrBuilder`
  `deleteAll(String str)`
  Deprecated.
  Deletes the string wherever it occurs in the builder.
  `StrBuilder`
  `deleteAll(StrMatcher matcher)`
  Deprecated.
  Deletes all parts of the builder that the matcher matches.
  `StrBuilder`
  `deleteCharAt(int index)`
  Deprecated.
  Deletes the character at the specified index.
  `StrBuilder`
  `deleteFirst(char ch)`
  Deprecated.
  Deletes the character wherever it occurs in the builder.
  `StrBuilder`
  `deleteFirst(String str)`
  Deprecated.
  Deletes the string wherever it occurs in the builder.
  `StrBuilder`
  `deleteFirst(StrMatcher matcher)`
  Deprecated.
  Deletes the first match within the builder using the specified matcher.
  `boolean`
  `endsWith(String str)`
  Deprecated.
  Tests whether this builder ends with the specified string.
  `StrBuilder`
  `ensureCapacity(int capacity)`
  Deprecated.
  Tests the capacity and ensures that it is at least the size specified.
  `boolean`
  `equals(Object obj)`
  Deprecated.
  Tests the contents of this builder against another to see if they contain the same character content.
  `boolean`
  `equals(StrBuilder other)`
  Deprecated.
  Tests the contents of this builder against another to see if they contain the same character content.
  `boolean`
  `equalsIgnoreCase(StrBuilder other)`
  Deprecated.
  Tests the contents of this builder against another to see if they contain the same character content ignoring case.
  `String`
  `get()`
  Deprecated.
  Converts this instance to a String.
  `char[]`
  `getChars(char[] destination)`
  Deprecated.
  Copies the character array into the specified array.
  `void`
  `getChars(int startIndex, int endIndex, char[] destination, int destinationIndex)`
  Deprecated.
  Copies the character array into the specified array.
  `String`
  `getNewLineText()`
  Deprecated.
  Gets the text to be appended when a `new line` is added.
  `String`
  `getNullText()`
  Deprecated.
  Gets the text to be appended when null is added.
  `int`
  `hashCode()`
  Deprecated.
  Gets a suitable hash code for this builder.
  `int`
  `indexOf(char ch)`
  Deprecated.
  Searches the string builder to find the first reference to the specified char.
  `int`
  `indexOf(char ch, int startIndex)`
  Deprecated.
  Searches the string builder to find the first reference to the specified char.
  `int`
  `indexOf(String str)`
  Deprecated.
  Searches the string builder to find the first reference to the specified string.
  `int`
  `indexOf(String str, int startIndex)`
  Deprecated.
  Searches the string builder to find the first reference to the specified string starting searching from the given index.
  `int`
  `indexOf(StrMatcher matcher)`
  Deprecated.
  Searches the string builder using the matcher to find the first match.
  `int`
  `indexOf(StrMatcher matcher, int startIndex)`
  Deprecated.
  Searches the string builder using the matcher to find the first match searching from the given index.
  `StrBuilder`
  `insert(int index, boolean value)`
  Deprecated.
  Inserts the value into this builder.
  `StrBuilder`
  `insert(int index, char value)`
  Deprecated.
  Inserts the value into this builder.
  `StrBuilder`
  `insert(int index, char[] chars)`
  Deprecated.
  Inserts the character array into this builder.
  `StrBuilder`
  `insert(int index, char[] chars, int offset, int length)`
  Deprecated.
  Inserts part of the character array into this builder.
  `StrBuilder`
  `insert(int index, double value)`
  Deprecated.
  Inserts the value into this builder.
  `StrBuilder`
  `insert(int index, float value)`
  Deprecated.
  Inserts the value into this builder.
  `StrBuilder`
  `insert(int index, int value)`
  Deprecated.
  Inserts the value into this builder.
  `StrBuilder`
  `insert(int index, long value)`
  Deprecated.
  Inserts the value into this builder.
  `StrBuilder`
  `insert(int index, Object obj)`
  Deprecated.
  Inserts the string representation of an object into this builder.
  `StrBuilder`
  `insert(int index, String str)`
  Deprecated.
  Inserts the string into this builder.
  `boolean`
  `isEmpty()`
  Deprecated.
  Tests if the string builder is empty (convenience Collections API style method).
  `boolean`
  `isNotEmpty()`
  Deprecated.
  Tests if the string builder is not empty (convenience Collections API style method).
  `int`
  `lastIndexOf(char ch)`
  Deprecated.
  Searches the string builder to find the last reference to the specified char.
  `int`
  `lastIndexOf(char ch, int startIndex)`
  Deprecated.
  Searches the string builder to find the last reference to the specified char.
  `int`
  `lastIndexOf(String str)`
  Deprecated.
  Searches the string builder to find the last reference to the specified string.
  `int`
  `lastIndexOf(String str, int startIndex)`
  Deprecated.
  Searches the string builder to find the last reference to the specified string starting searching from the given index.
  `int`
  `lastIndexOf(StrMatcher matcher)`
  Deprecated.
  Searches the string builder using the matcher to find the last match.
  `int`
  `lastIndexOf(StrMatcher matcher, int startIndex)`
  Deprecated.
  Searches the string builder using the matcher to find the last match searching from the given index.
  `String`
  `leftString(int length)`
  Deprecated.
  Extracts the leftmost characters from the string builder without throwing an exception.
  `int`
  `length()`
  Deprecated.
  Gets the length of the string builder.
  `String`
  `midString(int index, int length)`
  Deprecated.
  Extracts some characters from the middle of the string builder without throwing an exception.
  `StrBuilder`
  `minimizeCapacity()`
  Deprecated.
  Minimizes the capacity to the actual length of the string.
  `int`
  `readFrom(Readable readable)`
  Deprecated.
  If possible, reads chars from the provided `Readable` directly into underlying character buffer without making extra copies.
  `StrBuilder`
  `replace(int startIndex, int endIndex, String replaceStr)`
  Deprecated.
  Replaces a portion of the string builder with another string.
  `StrBuilder`
  `replace(StrMatcher matcher, String replaceStr, int startIndex, int endIndex, int replaceCount)`
  Deprecated.
  Advanced search and replaces within the builder using a matcher.
  `StrBuilder`
  `replaceAll(char search, char replace)`
  Deprecated.
  Replaces the search character with the replace character throughout the builder.
  `StrBuilder`
  `replaceAll(String searchStr, String replaceStr)`
  Deprecated.
  Replaces the search string with the replace string throughout the builder.
  `StrBuilder`
  `replaceAll(StrMatcher matcher, String replaceStr)`
  Deprecated.
  Replaces all matches within the builder with the replace string.
  `StrBuilder`
  `replaceFirst(char search, char replace)`
  Deprecated.
  Replaces the first instance of the search character with the replace character in the builder.
  `StrBuilder`
  `replaceFirst(String searchStr, String replaceStr)`
  Deprecated.
  Replaces the first instance of the search string with the replace string.
  `StrBuilder`
  `replaceFirst(StrMatcher matcher, String replaceStr)`
  Deprecated.
  Replaces the first match within the builder with the replace string.
  `StrBuilder`
  `reverse()`
  Deprecated.
  Reverses the string builder placing each character in the opposite index.
  `String`
  `rightString(int length)`
  Deprecated.
  Extracts the rightmost characters from the string builder without throwing an exception.
  `StrBuilder`
  `setCharAt(int index, char ch)`
  Deprecated.
  Sets the character at the specified index.
  `StrBuilder`
  `setLength(int length)`
  Deprecated.
  Updates the length of the builder by either dropping the last characters or adding filler of Unicode zero.
  `StrBuilder`
  `setNewLineText(String newLine)`
  Deprecated.
  Sets the text to be appended when `new line` is called.
  `StrBuilder`
  `setNullText(String nullText)`
  Deprecated.
  Sets the text to be appended when null is added.
  `int`
  `size()`
  Deprecated.
  Gets the length of the string builder.
  `boolean`
  `startsWith(String str)`
  Deprecated.
  Checks whether this builder starts with the specified string.
  `CharSequence`
  `subSequence(int startIndex, int endIndex)`
  Deprecated.
  `String`
  `substring(int start)`
  Deprecated.
  Extracts a portion of this string builder as a string.
  `String`
  `substring(int startIndex, int endIndex)`
  Deprecated.
  Extracts a portion of this string builder as a string.
  `char[]`
  `toCharArray()`
  Deprecated.
  Copies the builder's character array into a new character array.
  `char[]`
  `toCharArray(int startIndex, int endIndex)`
  Deprecated.
  Copies part of the builder's character array into a new character array.
  `String`
  `toString()`
  Deprecated.
  Gets a String version of the string builder, creating a new instance each time the method is called.
  `StringBuffer`
  `toStringBuffer()`
  Deprecated.
  Gets a StringBuffer version of the string builder, creating a new instance each time the method is called.
  `StringBuilder`
  `toStringBuilder()`
  Deprecated.
  Gets a StringBuilder version of the string builder, creating a new instance each time the method is called.
  `StrBuilder`
  `trim()`
  Deprecated.
  Trims the builder by removing characters less than or equal to a space from the beginning and end.
  `protected void`
  `validateIndex(int index)`
  Deprecated.
  Validates parameters defining a single index in the builder.
  `protected int`
  `validateRange(int startIndex, int endIndex)`
  Deprecated.
  Validates parameters defining a range of the builder.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface CharSequence

  `chars, codePoints`

- ## Constructor Details

  - ### StrBuilder

    public StrBuilder()
    Deprecated.
    Constructs an empty builder initial capacity 32 characters.

  - ### StrBuilder

    public StrBuilder(int initialCapacity)
    Deprecated.
    Constructs an empty builder the specified initial capacity.
    Parameters:
      `initialCapacity` - the initial capacity, zero or less will be converted to 32.

  - ### StrBuilder

    public StrBuilder(String str)
    Deprecated.
    Constructs a builder from the string, allocating 32 extra characters for growth.
    Parameters:
      `str` - the string to copy, null treated as blank string.

- ## Method Details

  - ### append

    public StrBuilder append(boolean value)
    Deprecated.
    Appends a boolean value to the string builder.
    Parameters:
      `value` - the value to append.
    Returns:
      `this` instance.

  - ### append

    public StrBuilder append(char ch)
    Deprecated.
    Appends a char value to the string builder.
    Specified by:
      `append` in interface `Appendable`
    Parameters:
      `ch` - the value to append.
    Returns:
      `this` instance.

  - ### append

    public StrBuilder append(char[] chars)
    Deprecated.
    Appends a char array to the string builder. Appending null will call `appendNull()`.
    Parameters:
      `chars` - the char array to append.
    Returns:
      `this` instance.

  - ### append

    public StrBuilder append(char[] chars, int startIndex, int length)
    Deprecated.
    Appends a char array to the string builder. Appending null will call `appendNull()`.
    Parameters:
      `chars` - the char array to append.
      `startIndex` - the start index, inclusive, must be valid.
      `length` - the length to append, must be valid.
    Returns:
      `this` instance.

  - ### append

    public StrBuilder append(CharBuffer buf)
    Deprecated.
    Appends the contents of a char buffer to this string builder. Appending null will call `appendNull()`.
    Parameters:
      `buf` - the char buffer to append.
    Returns:
      `this` instance.

  - ### append

    public StrBuilder append(CharBuffer buf, int startIndex, int length)
    Deprecated.
    Appends the contents of a char buffer to this string builder. Appending null will call `appendNull()`.
    Parameters:
      `buf` - the char buffer to append.
      `startIndex` - the start index, inclusive, must be valid.
      `length` - the length to append, must be valid.
    Returns:
      `this` instance.

  - ### append

    public StrBuilder append(CharSequence seq)
    Deprecated.
    Appends a CharSequence to this string builder. Appending null will call `appendNull()`.
    Specified by:
      `append` in interface `Appendable`
    Parameters:
      `seq` - the CharSequence to append.
    Returns:
      `this` instance.

  - ### append

    public StrBuilder append(CharSequence seq, int startIndex, int length)
    Deprecated.
    Appends part of a CharSequence to this string builder. Appending null will call `appendNull()`.
    Specified by:
      `append` in interface `Appendable`
    Parameters:
      `seq` - the CharSequence to append.
      `startIndex` - the start index, inclusive, must be valid.
      `length` - the length to append, must be valid.
    Returns:
      `this` instance.

  - ### append

    public StrBuilder append(double value)
    Deprecated.
    Appends a double value to the string builder using `String.valueOf`.
    Parameters:
      `value` - the value to append.
    Returns:
      `this` instance.

  - ### append

    public StrBuilder append(float value)
    Deprecated.
    Appends a float value to the string builder using `String.valueOf`.
    Parameters:
      `value` - the value to append.
    Returns:
      `this` instance.

  - ### append

    public StrBuilder append(int value)
    Deprecated.
    Appends an int value to the string builder using `String.valueOf`.
    Parameters:
      `value` - the value to append.
    Returns:
      `this` instance.

  - ### append

    public StrBuilder append(long value)
    Deprecated.
    Appends a long value to the string builder using `String.valueOf`.
    Parameters:
      `value` - the value to append.
    Returns:
      `this` instance.

  - ### append

    public StrBuilder append(Object obj)
    Deprecated.
    Appends an object to this string builder. Appending null will call `appendNull()`.
    Parameters:
      `obj` - the object to append.
    Returns:
      `this` instance.

  - ### append

    public StrBuilder append(StrBuilder str)
    Deprecated.
    Appends another string builder to this string builder. Appending null will call `appendNull()`.
    Parameters:
      `str` - the string builder to append.
    Returns:
      `this` instance.

  - ### append

    public StrBuilder append(StrBuilder str, int startIndex, int length)
    Deprecated.
    Appends part of a string builder to this string builder. Appending null will call `appendNull()`.
    Parameters:
      `str` - the string to append.
      `startIndex` - the start index, inclusive, must be valid.
      `length` - the length to append, must be valid.
    Returns:
      `this` instance.

  - ### append

    public StrBuilder append(String str)
    Deprecated.
    Appends a string to this string builder. Appending null will call `appendNull()`.
    Parameters:
      `str` - the string to append.
    Returns:
      `this` instance.

  - ### append

    public StrBuilder append(String str, int startIndex, int length)
    Deprecated.
    Appends part of a string to this string builder. Appending null will call `appendNull()`.
    Parameters:
      `str` - the string to append.
      `startIndex` - the start index, inclusive, must be valid.
      `length` - the length to append, must be valid.
    Returns:
      `this` instance.

  - ### append

    public StrBuilder append(String format, Object... objs)
    Deprecated.
    Calls `String.format(String, Object...)` and appends the result.
    Parameters:
      `format` - the format string.
      `objs` - the objects to use in the format string.
    Returns:
      `this` to enable chaining.
    See Also:
      - `String.format(String, Object...)`

  - ### append

    public StrBuilder append(StringBuffer str)
    Deprecated.
    Appends a string buffer to this string builder. Appending null will call `appendNull()`.
    Parameters:
      `str` - the string buffer to append.
    Returns:
      `this` instance.

  - ### append

    public StrBuilder append(StringBuffer str, int startIndex, int length)
    Deprecated.
    Appends part of a string buffer to this string builder. Appending null will call `appendNull()`.
    Parameters:
      `str` - the string to append.
      `startIndex` - the start index, inclusive, must be valid.
      `length` - the length to append, must be valid.
    Returns:
      `this` instance.

  - ### append

    public StrBuilder append(StringBuilder str)
    Deprecated.
    Appends a StringBuilder to this string builder. Appending null will call `appendNull()`.
    Parameters:
      `str` - the StringBuilder to append.
    Returns:
      `this` instance.

  - ### append

    public StrBuilder append(StringBuilder str, int startIndex, int length)
    Deprecated.
    Appends part of a StringBuilder to this string builder. Appending null will call `appendNull()`.
    Parameters:
      `str` - the StringBuilder to append.
      `startIndex` - the start index, inclusive, must be valid.
      `length` - the length to append, must be valid.
    Returns:
      `this` instance.

  - ### appendAll

    public StrBuilder appendAll(Iterable<?> iterable)
    Deprecated.
    Appends each item in an iterable to the builder without any separators. Appending a null iterable will have no effect. Each object is appended using `append(Object)`.
    Parameters:
      `iterable` - the iterable to append.
    Returns:
      `this` instance.

  - ### appendAll

    public StrBuilder appendAll(Iterator<?> it)
    Deprecated.
    Appends each item in an iterator to the builder without any separators. Appending a null iterator will have no effect. Each object is appended using `append(Object)`.
    Parameters:
      `it` - the iterator to append.
    Returns:
      `this` instance.

  - ### appendAll

    public <T> StrBuilder appendAll(T... array)
    Deprecated.
    Appends each item in an array to the builder without any separators. Appending a null array will have no effect. Each object is appended using `append(Object)`.
    Type Parameters:
      `T` - the element type.
    Parameters:
      `array` - the array to append.
    Returns:
      `this` instance.

  - ### appendFixedWidthPadLeft

    public StrBuilder appendFixedWidthPadLeft(int value, int width, char padChar)
    Deprecated.
    Appends an object to the builder padding on the left to a fixed width. The `String.valueOf` of the `int` value is used. If the formatted value is larger than the length, the left hand side is lost.
    Parameters:
      `value` - the value to append.
      `width` - the fixed field width, zero or negative has no effect.
      `padChar` - the pad character to use.
    Returns:
      `this` instance.

  - ### appendFixedWidthPadLeft

    public StrBuilder appendFixedWidthPadLeft(Object obj, int width, char padChar)
    Deprecated.
    Appends an object to the builder padding on the left to a fixed width. The `toString` of the object is used. If the object is larger than the length, the left hand side is lost. If the object is null, the null text value is used.
    Parameters:
      `obj` - the object to append, null uses null text
      `width` - the fixed field width, zero or negative has no effect
      `padChar` - the pad character to use
    Returns:
      `this` instance.

  - ### appendFixedWidthPadRight

    public StrBuilder appendFixedWidthPadRight(int value, int width, char padChar)
    Deprecated.
    Appends an object to the builder padding on the right to a fixed length. The `String.valueOf` of the `int` value is used. If the object is larger than the length, the right hand side is lost.
    Parameters:
      `value` - the value to append.
      `width` - the fixed field width, zero or negative has no effect.
      `padChar` - the pad character to use.
    Returns:
      `this` instance.

  - ### appendFixedWidthPadRight

    public StrBuilder appendFixedWidthPadRight(Object obj, int width, char padChar)
    Deprecated.
    Appends an object to the builder padding on the right to a fixed length. The `toString` of the object is used. If the object is larger than the length, the right hand side is lost. If the object is null, null text value is used.
    Parameters:
      `obj` - the object to append, null uses null text.
      `width` - the fixed field width, zero or negative has no effect.
      `padChar` - the pad character to use.
    Returns:
      `this` instance.

  - ### appendln

    public StrBuilder appendln(boolean value)
    Deprecated.
    Appends a boolean value followed by a `new line` to the string builder.
    Parameters:
      `value` - the value to append.
    Returns:
      `this` instance.
    See Also:
      - `appendNewLine()`

  - ### appendln

    public StrBuilder appendln(char ch)
    Deprecated.
    Appends a char value followed by a `new line` to the string builder.
    Parameters:
      `ch` - the value to append.
    Returns:
      `this` instance.
    See Also:
      - `appendNewLine()`

  - ### appendln

    public StrBuilder appendln(char[] chars)
    Deprecated.
    Appends a char array followed by a `new line` to the string builder. Appending null will call `appendNull()`.
    Parameters:
      `chars` - the char array to append.
    Returns:
      `this` instance.
    See Also:
      - `appendNewLine()`

  - ### appendln

    public StrBuilder appendln(char[] chars, int startIndex, int length)
    Deprecated.
    Appends a char array followed by a `new line` to the string builder. Appending null will call `appendNull()`.
    Parameters:
      `chars` - the char array to append.
      `startIndex` - the start index, inclusive, must be valid.
      `length` - the length to append, must be valid.
    Returns:
      `this` instance.
    See Also:
      - `appendNewLine()`

  - ### appendln

    public StrBuilder appendln(double value)
    Deprecated.
    Appends a double value followed by a `new line` to the string builder using `String.valueOf`.
    Parameters:
      `value` - the value to append.
    Returns:
      `this` instance.
    See Also:
      - `appendNewLine()`

  - ### appendln

    public StrBuilder appendln(float value)
    Deprecated.
    Appends a float value followed by a `new line` to the string builder using `String.valueOf`.
    Parameters:
      `value` - the value to append.
    Returns:
      `this` instance.
    See Also:
      - `appendNewLine()`

  - ### appendln

    public StrBuilder appendln(int value)
    Deprecated.
    Appends an int value followed by a `new line` to the string builder using `String.valueOf`.
    Parameters:
      `value` - the value to append.
    Returns:
      `this` instance.
    See Also:
      - `appendNewLine()`

  - ### appendln

    public StrBuilder appendln(long value)
    Deprecated.
    Appends a long value followed by a `new line` to the string builder using `String.valueOf`.
    Parameters:
      `value` - the value to append.
    Returns:
      `this` instance.
    See Also:
      - `appendNewLine()`

  - ### appendln

    public StrBuilder appendln(Object obj)
    Deprecated.
    Appends an object followed by a `new line` to this string builder. Appending null will call `appendNull()`.
    Parameters:
      `obj` - the object to append.
    Returns:
      `this` instance.
    See Also:
      - `appendNewLine()`

  - ### appendln

    public StrBuilder appendln(StrBuilder str)
    Deprecated.
    Appends another string builder followed by a `new line` to this string builder. Appending null will call `appendNull()`.
    Parameters:
      `str` - the string builder to append.
    Returns:
      `this` instance.
    See Also:
      - `appendNewLine()`

  - ### appendln

    public StrBuilder appendln(StrBuilder str, int startIndex, int length)
    Deprecated.
    Appends part of a string builder followed by a `new line` to this string builder. Appending null will call `appendNull()`.
    Parameters:
      `str` - the string to append.
      `startIndex` - the start index, inclusive, must be valid.
      `length` - the length to append, must be valid.
    Returns:
      `this` instance.
    See Also:
      - `appendNewLine()`

  - ### appendln

    public StrBuilder appendln(String str)
    Deprecated.
    Appends a string followed by a `new line` to this string builder. Appending null will call `appendNull()`.
    Parameters:
      `str` - the string to append.
    Returns:
      `this` instance.
    See Also:
      - `appendNewLine()`

  - ### appendln

    public StrBuilder appendln(String str, int startIndex, int length)
    Deprecated.
    Appends part of a string followed by a `new line` to this string builder. Appending null will call `appendNull()`.
    Parameters:
      `str` - the string to append.
      `startIndex` - the start index, inclusive, must be valid.
      `length` - the length to append, must be valid.
    Returns:
      `this` instance.
    See Also:
      - `appendNewLine()`

  - ### appendln

    public StrBuilder appendln(String format, Object... objs)
    Deprecated.
    Calls `String.format(String, Object...)` and appends the result.
    Parameters:
      `format` - the format string.
      `objs` - the objects to use in the format string.
    Returns:
      `this` to enable chaining.
    See Also:
      - `String.format(String, Object...)`
      - `appendNewLine()`

  - ### appendln

    public StrBuilder appendln(StringBuffer str)
    Deprecated.
    Appends a string buffer followed by a `new line` to this string builder. Appending null will call `appendNull()`.
    Parameters:
      `str` - the string buffer to append.
    Returns:
      `this` instance.
    See Also:
      - `appendNewLine()`

  - ### appendln

    public StrBuilder appendln(StringBuffer str, int startIndex, int length)
    Deprecated.
    Appends part of a string buffer followed by a `new line` to this string builder. Appending null will call `appendNull()`.
    Parameters:
      `str` - the string to append.
      `startIndex` - the start index, inclusive, must be valid.
      `length` - the length to append, must be valid.
    Returns:
      `this` instance.
    See Also:
      - `appendNewLine()`

  - ### appendln

    public StrBuilder appendln(StringBuilder str)
    Deprecated.
    Appends a string builder followed by a `new line` to this string builder. Appending null will call `appendNull()`.
    Parameters:
      `str` - the string builder to append.
    Returns:
      `this` instance.
    See Also:
      - `appendNewLine()`

  - ### appendln

    public StrBuilder appendln(StringBuilder str, int startIndex, int length)
    Deprecated.
    Appends part of a string builder followed by a `new line` to this string builder. Appending null will call `appendNull()`.
    Parameters:
      `str` - the string builder to append.
      `startIndex` - the start index, inclusive, must be valid.
      `length` - the length to append, must be valid.
    Returns:
      `this` instance.
    See Also:
      - `appendNewLine()`

  - ### appendNewLine

    public StrBuilder appendNewLine()
    Deprecated.
    Appends this builder's new line string to this builder.

    By default, the new line is the system default from `System.lineSeparator()`.

    The new line string can be changed using `setNewLineText(String)`. For example, you can use this to force the output to always use Unix line endings even when on Windows.

    Returns:
      `this` instance.
    See Also:
      - `getNewLineText()`
      - `setNewLineText(String)`

  - ### appendNull

    public StrBuilder appendNull()
    Deprecated.
    Appends this builder's null text to this builder.
    Returns:
      `this` instance.

  - ### appendPadding

    public StrBuilder appendPadding(int length, char padChar)
    Deprecated.
    Appends the pad character to the builder the specified number of times.
    Parameters:
      `length` - the length to append, negative means no append.
      `padChar` - the character to append.
    Returns:
      `this` instance.

  - ### appendSeparator

    public StrBuilder appendSeparator(char separator)
    Deprecated.
    Appends a separator if the builder is currently non-empty. The separator is appended using `append(char)`.

    This method is useful for adding a separator each time around the loop except the first.

        for (Iterator it = list.iterator(); it.hasNext();) {
            appendSeparator(',');
            append(it.next());
        }

    Note that for this simple example, you should use `appendWithSeparators(Iterable, String)`.

    Parameters:
      `separator` - the separator to use.
    Returns:
      `this` instance.

  - ### appendSeparator

    public StrBuilder appendSeparator(char standard, char defaultIfEmpty)
    Deprecated.
    Appends one of both separators to the builder If the builder is currently empty it will append the defaultIfEmpty-separator Otherwise it will append the standard-separator The separator is appended using `append(char)`.
    Parameters:
      `standard` - the separator if builder is not empty.
      `defaultIfEmpty` - the separator if builder is empty.
    Returns:
      `this` instance.

  - ### appendSeparator

    public StrBuilder appendSeparator(char separator, int loopIndex)
    Deprecated.
    Appends a separator to the builder if the loop index is greater than zero. The separator is appended using `append(char)`.

    This method is useful for adding a separator each time around the loop except the first.

        for (int i = 0; i < list.size(); i++) {
            appendSeparator(",", i);
            append(list.get(i));
        }

    Note that for this simple example, you should use `appendWithSeparators(Iterable, String)`.

    Parameters:
      `separator` - the separator to use.
      `loopIndex` - the loop index.
    Returns:
      `this` instance.

  - ### appendSeparator

    public StrBuilder appendSeparator(String separator)
    Deprecated.
    Appends a separator if the builder is currently non-empty. Appending a null separator will have no effect. The separator is appended using `append(String)`.

    This method is useful for adding a separator each time around the loop except the first.

        for (Iterator it = list.iterator(); it.hasNext();) {
            appendSeparator(",");
            append(it.next());
        }

    Note that for this simple example, you should use `appendWithSeparators(Iterable, String)`.

    Parameters:
      `separator` - the separator to use, null means no separator.
    Returns:
      `this` instance.

  - ### appendSeparator

    public StrBuilder appendSeparator(String separator, int loopIndex)
    Deprecated.
    Appends a separator to the builder if the loop index is greater than zero. Appending a null separator will have no effect. The separator is appended using `append(String)`.

    This method is useful for adding a separator each time around the loop except the first.

        for (int i = 0; i < list.size(); i++) {
            appendSeparator(",", i);
            append(list.get(i));
        }

    Note that for this simple example, you should use `appendWithSeparators(Iterable, String)`.

    Parameters:
      `separator` - the separator to use, null means no separator.
      `loopIndex` - the loop index.
    Returns:
      `this` instance.

  - ### appendSeparator

    public StrBuilder appendSeparator(String standard, String defaultIfEmpty)
    Deprecated.
    Appends one of both separators to the StrBuilder. If the builder is currently empty it will append the defaultIfEmpty-separator Otherwise it will append the standard-separator

    Appending a null separator will have no effect. The separator is appended using `append(String)`.

    This method is for example useful for constructing queries

        StrBuilder whereClause = new StrBuilder();
        if (searchCommand.getPriority() != null) {
          whereClause.appendSeparator(" and", " where");
          whereClause.append(" priority = ?")
        }
        if (searchCommand.getComponent() != null) {
          whereClause.appendSeparator(" and", " where");
          whereClause.append(" component = ?")
        }
        selectClause.append(whereClause)

    Parameters:
      `standard` - the separator if builder is not empty, null means no separator.
      `defaultIfEmpty` - the separator if builder is empty, null means no separator.
    Returns:
      `this` instance.

  - ### appendTo

    public void appendTo(Appendable appendable) throws IOException
    Deprecated.
    Appends current contents of this `StrBuilder` to the provided `Appendable`.

    This method tries to avoid doing any extra copies of contents.

    Parameters:
      `appendable` - the appendable to append data to.
    Throws:
      `IOException` - if an I/O error occurs.
    See Also:
      - `readFrom(Readable)`

  - ### appendWithSeparators

    public StrBuilder appendWithSeparators(Iterable<?> iterable, String separator)
    Deprecated.
    Appends an iterable placing separators between each value, but not before the first or after the last. Appending a null iterable will have no effect. Each object is appended using `append(Object)`.
    Parameters:
      `iterable` - the iterable to append.
      `separator` - the separator to use, null means no separator.
    Returns:
      `this` instance.

  - ### appendWithSeparators

    public StrBuilder appendWithSeparators(Iterator<?> iterator, String separator)
    Deprecated.
    Appends an iterator placing separators between each value, but not before the first or after the last. Appending a null iterator will have no effect. Each object is appended using `append(Object)`.
    Parameters:
      `iterator` - the iterator to append.
      `separator` - the separator to use, null means no separator.
    Returns:
      `this` instance.

  - ### appendWithSeparators

    public StrBuilder appendWithSeparators(Object[] array, String separator)
    Deprecated.
    Appends an array placing separators between each value, but not before the first or after the last. Appending a null array will have no effect. Each object is appended using `append(Object)`.
    Parameters:
      `array` - the array to append.
      `separator` - the separator to use, null means no separator.
    Returns:
      `this` instance.

  - ### asReader

    public Reader asReader()
    Deprecated.
    Gets the contents of this builder as a Reader.

    This method allows the contents of the builder to be read using any standard method that expects a Reader.

    To use, simply create a `StrBuilder`, populate it with data, call `asReader`, and then read away.

    The internal character array is shared between the builder and the reader. This allows you to append to the builder after creating the reader, and the changes will be picked up. Note however, that no synchronization occurs, so you must perform all operations with the builder and the reader in one thread.

    The returned reader supports marking, and ignores the flush method.

    Returns:
      a reader that reads from this builder.

  - ### asTokenizer

    public StrTokenizer asTokenizer()
    Deprecated.
    Creates a tokenizer that can tokenize the contents of this builder.

    This method allows the contents of this builder to be tokenized. The tokenizer will be setup by default to tokenize on space, tab, newline and form feed (as per StringTokenizer). These values can be changed on the tokenizer class, before retrieving the tokens.

    The returned tokenizer is linked to this builder. You may intermix calls to the builder and tokenizer within certain limits, however there is no synchronization. Once the tokenizer has been used once, it must be `reset` to pickup the latest changes in the builder. For example:

        StrBuilder b = new StrBuilder();
        b.append("a b ");
        StrTokenizer t = b.asTokenizer();
        String[] tokens1 = t.getTokenArray(); // returns a,b
        b.append("c d ");
        String[] tokens2 = t.getTokenArray(); // returns a,b (c and d ignored)
        t.reset(); // reset causes builder changes to be picked up
        String[] tokens3 = t.getTokenArray(); // returns a,b,c,d

    In addition to simply intermixing appends and tokenization, you can also call the set methods on the tokenizer to alter how it tokenizes. Just remember to call reset when you want to pickup builder changes.

    Calling `StrTokenizer.reset(String)` or `StrTokenizer.reset(char[])` with a non-null value will break the link with the builder.

    Returns:
      a tokenizer that is linked to this builder.

  - ### asWriter

    public Writer asWriter()
    Deprecated.
    Gets this builder as a Writer that can be written to.

    This method allows you to populate the contents of the builder using any standard method that takes a Writer.

    To use, simply create a `StrBuilder`, call `asWriter`, and populate away. The data is available at any time using the methods of the `StrBuilder`.

    The internal character array is shared between the builder and the writer. This allows you to intermix calls that append to the builder and write using the writer and the changes will be occur correctly. Note however, that no synchronization occurs, so you must perform all operations with the builder and the writer in one thread.

    The returned writer ignores the close and flush methods.

    Returns:
      a writer that populates this builder.

  - ### build

    @Deprecated public String build()
    Deprecated.
    Use `get()`.
    Converts this instance to a String.
    Specified by:
      `build` in interface `Builder<String>`
    Returns:
      This instance as a String.
    See Also:
      - `toString()`

  - ### capacity

    public int capacity()
    Deprecated.
    Gets the current size of the internal character array buffer.
    Returns:
      The capacity

  - ### charAt

    public char charAt(int index)
    Deprecated.
    Gets the character at the specified index.
    Specified by:
      `charAt` in interface `CharSequence`
    Parameters:
      `index` - the index to retrieve, must be valid
    Returns:
      The character at the index
    Throws:
      `IndexOutOfBoundsException` - if the index is invalid
    See Also:
      - `setCharAt(int, char)`
      - `deleteCharAt(int)`

  - ### clear

    public StrBuilder clear()
    Deprecated.
    Clears the string builder (convenience Collections API style method).

    This method does not reduce the size of the internal character buffer. To do that, call `clear()` followed by `minimizeCapacity()`.

    This method is the same as `setLength(int)` called with zero and is provided to match the API of Collections.

    Returns:
      `this` instance.

  - ### contains

    public boolean contains(char ch)
    Deprecated.
    Checks if the string builder contains the specified char.
    Parameters:
      `ch` - the character to find.
    Returns:
      true if the builder contains the character.

  - ### contains

    public boolean contains(String str)
    Deprecated.
    Tests if the string builder contains the specified string.
    Parameters:
      `str` - the string to find.
    Returns:
      true if the builder contains the string.

  - ### contains

    public boolean contains(StrMatcher matcher)
    Deprecated.
    Tests if the string builder contains a string matched using the specified matcher.

    Matchers can be used to perform advanced searching behavior. For example you could write a matcher to search for the character 'a' followed by a number.

    Parameters:
      `matcher` - the matcher to use, null returns -1.
    Returns:
      true if the matcher finds a match in the builder.

  - ### delete

    public StrBuilder delete(int startIndex, int endIndex)
    Deprecated.
    Deletes the characters between the two specified indices.
    Parameters:
      `startIndex` - the start index, inclusive, must be valid.
      `endIndex` - the end index, exclusive, must be valid except that if too large it is treated as end of string.
    Returns:
      `this` instance.
    Throws:
      `IndexOutOfBoundsException` - if the index is invalid.

  - ### deleteAll

    public StrBuilder deleteAll(char ch)
    Deprecated.
    Deletes the character wherever it occurs in the builder.
    Parameters:
      `ch` - the character to delete.
    Returns:
      `this` instance.

  - ### deleteAll

    public StrBuilder deleteAll(String str)
    Deprecated.
    Deletes the string wherever it occurs in the builder.
    Parameters:
      `str` - the string to delete, null causes no action.
    Returns:
      `this` instance.

  - ### deleteAll

    public StrBuilder deleteAll(StrMatcher matcher)
    Deprecated.
    Deletes all parts of the builder that the matcher matches.

    Matchers can be used to perform advanced deletion behavior. For example you could write a matcher to delete all occurrences where the character 'a' is followed by a number.

    Parameters:
      `matcher` - the matcher to use to find the deletion, null causes no action.
    Returns:
      `this` instance.

  - ### deleteCharAt

    public StrBuilder deleteCharAt(int index)
    Deprecated.
    Deletes the character at the specified index.
    Parameters:
      `index` - the index to delete.
    Returns:
      `this` instance.
    Throws:
      `IndexOutOfBoundsException` - if the index is invalid.
    See Also:
      - `charAt(int)`
      - `setCharAt(int, char)`

  - ### deleteFirst

    public StrBuilder deleteFirst(char ch)
    Deprecated.
    Deletes the character wherever it occurs in the builder.
    Parameters:
      `ch` - the character to delete.
    Returns:
      `this` instance.

  - ### deleteFirst

    public StrBuilder deleteFirst(String str)
    Deprecated.
    Deletes the string wherever it occurs in the builder.
    Parameters:
      `str` - the string to delete, null causes no action.
    Returns:
      `this` instance.

  - ### deleteFirst

    public StrBuilder deleteFirst(StrMatcher matcher)
    Deprecated.
    Deletes the first match within the builder using the specified matcher.

    Matchers can be used to perform advanced deletion behavior. For example you could write a matcher to delete where the character 'a' is followed by a number.

    Parameters:
      `matcher` - the matcher to use to find the deletion, null causes no action.
    Returns:
      `this` instance.

  - ### endsWith

    public boolean endsWith(String str)
    Deprecated.
    Tests whether this builder ends with the specified string.

    Note that this method handles null input quietly, unlike String.

    Parameters:
      `str` - the string to search for, null returns false.
    Returns:
      true if the builder ends with the string.

  - ### ensureCapacity

    public StrBuilder ensureCapacity(int capacity)
    Deprecated.
    Tests the capacity and ensures that it is at least the size specified.
    Parameters:
      `capacity` - the capacity to ensure.
    Returns:
      `this` instance.

  - ### equals

    public boolean equals(Object obj)
    Deprecated.
    Tests the contents of this builder against another to see if they contain the same character content.
    Overrides:
      `equals` in class `Object`
    Parameters:
      `obj` - the object to check, null returns false.
    Returns:
      true if the builders contain the same characters in the same order.

  - ### equals

    public boolean equals(StrBuilder other)
    Deprecated.
    Tests the contents of this builder against another to see if they contain the same character content.
    Parameters:
      `other` - the object to check, null returns false.
    Returns:
      true if the builders contain the same characters in the same order.

  - ### equalsIgnoreCase

    public boolean equalsIgnoreCase(StrBuilder other)
    Deprecated.
    Tests the contents of this builder against another to see if they contain the same character content ignoring case.
    Parameters:
      `other` - the object to check, null returns false.
    Returns:
      true if the builders contain the same characters in the same order.

  - ### get

    public String get()
    Deprecated.
    Converts this instance to a String.
    Specified by:
      `get` in interface `Supplier<String>`
    Returns:
      This instance as a String.
    Since:
      1.12.0
    See Also:
      - `toString()`

  - ### getChars

    public char[] getChars(char[] destination)
    Deprecated.
    Copies the character array into the specified array.
    Parameters:
      `destination` - the destination array, null will cause an array to be created.
    Returns:
      The input array, unless that was null or too small.

  - ### getChars

    public void getChars(int startIndex, int endIndex, char[] destination, int destinationIndex)
    Deprecated.
    Copies the character array into the specified array.
    Parameters:
      `startIndex` - first index to copy, inclusive, must be valid.
      `endIndex` - last index, exclusive, must be valid.
      `destination` - the destination array, must not be null or too small.
      `destinationIndex` - the index to start copying in destination.
    Throws:
      `NullPointerException` - if the array is null.
      `IndexOutOfBoundsException` - if any index is invalid.

  - ### getNewLineText

    public String getNewLineText()
    Deprecated.
    Gets the text to be appended when a `new line` is added.
    Returns:
      The new line text, `null` means use the system default from `System.lineSeparator()`.

  - ### getNullText

    public String getNullText()
    Deprecated.
    Gets the text to be appended when null is added.
    Returns:
      The null text, null means no append.

  - ### hashCode

    public int hashCode()
    Deprecated.
    Gets a suitable hash code for this builder.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      a hash code.

  - ### indexOf

    public int indexOf(char ch)
    Deprecated.
    Searches the string builder to find the first reference to the specified char.
    Parameters:
      `ch` - the character to find.
    Returns:
      The first index of the character, or -1 if not found.

  - ### indexOf

    public int indexOf(char ch, int startIndex)
    Deprecated.
    Searches the string builder to find the first reference to the specified char.
    Parameters:
      `ch` - the character to find.
      `startIndex` - the index to start at, invalid index rounded to edge.
    Returns:
      The first index of the character, or -1 if not found.

  - ### indexOf

    public int indexOf(String str)
    Deprecated.
    Searches the string builder to find the first reference to the specified string.

    Note that a null input string will return -1, whereas the JDK throws an exception.

    Parameters:
      `str` - the string to find, null returns -1.
    Returns:
      The first index of the string, or -1 if not found.

  - ### indexOf

    public int indexOf(String str, int startIndex)
    Deprecated.
    Searches the string builder to find the first reference to the specified string starting searching from the given index.

    Note that a null input string will return -1, whereas the JDK throws an exception.

    Parameters:
      `str` - the string to find, null returns -1.
      `startIndex` - the index to start at, invalid index rounded to edge.
    Returns:
      The first index of the string, or -1 if not found.

  - ### indexOf

    public int indexOf(StrMatcher matcher)
    Deprecated.
    Searches the string builder using the matcher to find the first match.

    Matchers can be used to perform advanced searching behavior. For example you could write a matcher to find the character 'a' followed by a number.

    Parameters:
      `matcher` - the matcher to use, null returns -1.
    Returns:
      The first index matched, or -1 if not found.

  - ### indexOf

    public int indexOf(StrMatcher matcher, int startIndex)
    Deprecated.
    Searches the string builder using the matcher to find the first match searching from the given index.

    Matchers can be used to perform advanced searching behavior. For example you could write a matcher to find the character 'a' followed by a number.

    Parameters:
      `matcher` - the matcher to use, null returns -1.
      `startIndex` - the index to start at, invalid index rounded to edge.
    Returns:
      The first index matched, or -1 if not found.

  - ### insert

    public StrBuilder insert(int index, boolean value)
    Deprecated.
    Inserts the value into this builder.
    Parameters:
      `index` - the index to add at, must be valid.
      `value` - the value to insert.
    Returns:
      `this` instance.
    Throws:
      `IndexOutOfBoundsException` - if the index is invalid.

  - ### insert

    public StrBuilder insert(int index, char value)
    Deprecated.
    Inserts the value into this builder.
    Parameters:
      `index` - the index to add at, must be valid.
      `value` - the value to insert.
    Returns:
      `this` instance.
    Throws:
      `IndexOutOfBoundsException` - if the index is invalid.

  - ### insert

    public StrBuilder insert(int index, char[] chars)
    Deprecated.
    Inserts the character array into this builder. Inserting null will use the stored null text value.
    Parameters:
      `index` - the index to add at, must be valid.
      `chars` - the char array to insert.
    Returns:
      `this` instance.
    Throws:
      `IndexOutOfBoundsException` - if the index is invalid.

  - ### insert

    public StrBuilder insert(int index, char[] chars, int offset, int length)
    Deprecated.
    Inserts part of the character array into this builder. Inserting null will use the stored null text value.
    Parameters:
      `index` - the index to add at, must be valid.
      `chars` - the char array to insert.
      `offset` - the offset into the character array to start at, must be valid.
      `length` - the length of the character array part to copy, must be positive.
    Returns:
      `this` instance.
    Throws:
      `IndexOutOfBoundsException` - if any index is invalid.

  - ### insert

    public StrBuilder insert(int index, double value)
    Deprecated.
    Inserts the value into this builder.
    Parameters:
      `index` - the index to add at, must be valid.
      `value` - the value to insert.
    Returns:
      `this` instance.
    Throws:
      `IndexOutOfBoundsException` - if the index is invalid.

  - ### insert

    public StrBuilder insert(int index, float value)
    Deprecated.
    Inserts the value into this builder.
    Parameters:
      `index` - the index to add at, must be valid.
      `value` - the value to insert.
    Returns:
      `this` instance.
    Throws:
      `IndexOutOfBoundsException` - if the index is invalid.

  - ### insert

    public StrBuilder insert(int index, int value)
    Deprecated.
    Inserts the value into this builder.
    Parameters:
      `index` - the index to add at, must be valid.
      `value` - the value to insert.
    Returns:
      `this` instance.
    Throws:
      `IndexOutOfBoundsException` - if the index is invalid.

  - ### insert

    public StrBuilder insert(int index, long value)
    Deprecated.
    Inserts the value into this builder.
    Parameters:
      `index` - the index to add at, must be valid.
      `value` - the value to insert.
    Returns:
      `this` instance.
    Throws:
      `IndexOutOfBoundsException` - if the index is invalid.

  - ### insert

    public StrBuilder insert(int index, Object obj)
    Deprecated.
    Inserts the string representation of an object into this builder. Inserting null will use the stored null text value.
    Parameters:
      `index` - the index to add at, must be valid.
      `obj` - the object to insert.
    Returns:
      `this` instance.
    Throws:
      `IndexOutOfBoundsException` - if the index is invalid.

  - ### insert

    public StrBuilder insert(int index, String str)
    Deprecated.
    Inserts the string into this builder. Inserting null will use the stored null text value.
    Parameters:
      `index` - the index to add at, must be valid.
      `str` - the string to insert.
    Returns:
      `this` instance.
    Throws:
      `IndexOutOfBoundsException` - if the index is invalid.

  - ### isEmpty

    public boolean isEmpty()
    Deprecated.
    Tests if the string builder is empty (convenience Collections API style method).

    This method is the same as checking `length()` and is provided to match the API of Collections.

    Returns:
      `true` if the size is `0`.

  - ### isNotEmpty

    public boolean isNotEmpty()
    Deprecated.
    Tests if the string builder is not empty (convenience Collections API style method).

    This method is the same as checking `length()` and is provided to match the API of Collections.

    Returns:
      `true` if the size is greater than `0`.
    Since:
      1.10.0

  - ### lastIndexOf

    public int lastIndexOf(char ch)
    Deprecated.
    Searches the string builder to find the last reference to the specified char.
    Parameters:
      `ch` - the character to find.
    Returns:
      The last index of the character, or -1 if not found.

  - ### lastIndexOf

    public int lastIndexOf(char ch, int startIndex)
    Deprecated.
    Searches the string builder to find the last reference to the specified char.
    Parameters:
      `ch` - the character to find.
      `startIndex` - the index to start at, invalid index rounded to edge.
    Returns:
      The last index of the character, or -1 if not found.

  - ### lastIndexOf

    public int lastIndexOf(String str)
    Deprecated.
    Searches the string builder to find the last reference to the specified string.

    Note that a null input string will return -1, whereas the JDK throws an exception.

    Parameters:
      `str` - the string to find, null returns -1.
    Returns:
      The last index of the string, or -1 if not found.

  - ### lastIndexOf

    public int lastIndexOf(String str, int startIndex)
    Deprecated.
    Searches the string builder to find the last reference to the specified string starting searching from the given index.

    Note that a null input string will return -1, whereas the JDK throws an exception.

    Parameters:
      `str` - the string to find, null returns -1.
      `startIndex` - the index to start at, invalid index rounded to edge.
    Returns:
      The last index of the string, or -1 if not found.

  - ### lastIndexOf

    public int lastIndexOf(StrMatcher matcher)
    Deprecated.
    Searches the string builder using the matcher to find the last match.

    Matchers can be used to perform advanced searching behavior. For example you could write a matcher to find the character 'a' followed by a number.

    Parameters:
      `matcher` - the matcher to use, null returns -1.
    Returns:
      The last index matched, or -1 if not found.

  - ### lastIndexOf

    public int lastIndexOf(StrMatcher matcher, int startIndex)
    Deprecated.
    Searches the string builder using the matcher to find the last match searching from the given index.

    Matchers can be used to perform advanced searching behavior. For example you could write a matcher to find the character 'a' followed by a number.

    Parameters:
      `matcher` - the matcher to use, null returns -1.
      `startIndex` - the index to start at, invalid index rounded to edge.
    Returns:
      The last index matched, or -1 if not found.

  - ### leftString

    public String leftString(int length)
    Deprecated.
    Extracts the leftmost characters from the string builder without throwing an exception.

    This method extracts the left `length` characters from the builder. If this many characters are not available, the whole builder is returned. Thus the returned string may be shorter than the length requested.

    Parameters:
      `length` - the number of characters to extract, negative returns empty string.
    Returns:
      The new string.

  - ### length

    public int length()
    Deprecated.
    Gets the length of the string builder.
    Specified by:
      `length` in interface `CharSequence`
    Returns:
      The length

  - ### midString

    public String midString(int index, int length)
    Deprecated.
    Extracts some characters from the middle of the string builder without throwing an exception.

    This method extracts `length` characters from the builder at the specified index. If the index is negative it is treated as zero. If the index is greater than the builder size, it is treated as the builder size. If the length is negative, the empty string is returned. If insufficient characters are available in the builder, as much as possible is returned. Thus the returned string may be shorter than the length requested.

    Parameters:
      `index` - the index to start at, negative means zero.
      `length` - the number of characters to extract, negative returns empty string.
    Returns:
      The new string.

  - ### minimizeCapacity

    public StrBuilder minimizeCapacity()
    Deprecated.
    Minimizes the capacity to the actual length of the string.
    Returns:
      `this` instance.

  - ### readFrom

    public int readFrom(Readable readable) throws IOException
    Deprecated.
    If possible, reads chars from the provided `Readable` directly into underlying character buffer without making extra copies.
    Parameters:
      `readable` - object to read from.
    Returns:
      The number of characters read.
    Throws:
      `IOException` - if an I/O error occurs.
    See Also:
      - `appendTo(Appendable)`

  - ### replace

    public StrBuilder replace(int startIndex, int endIndex, String replaceStr)
    Deprecated.
    Replaces a portion of the string builder with another string. The length of the inserted string does not have to match the removed length.
    Parameters:
      `startIndex` - the start index, inclusive, must be valid.
      `endIndex` - the end index, exclusive, must be valid except that if too large it is treated as end of string.
      `replaceStr` - the string to replace with, null means delete range.
    Returns:
      `this` instance.
    Throws:
      `IndexOutOfBoundsException` - if the index is invalid.

  - ### replace

    public StrBuilder replace(StrMatcher matcher, String replaceStr, int startIndex, int endIndex, int replaceCount)
    Deprecated.
    Advanced search and replaces within the builder using a matcher.

    Matchers can be used to perform advanced behavior. For example you could write a matcher to delete all occurrences where the character 'a' is followed by a number.

    Parameters:
      `matcher` - the matcher to use to find the deletion, null causes no action.
      `replaceStr` - the string to replace the match with, null is a delete.
      `startIndex` - the start index, inclusive, must be valid.
      `endIndex` - the end index, exclusive, must be valid except that if too large it is treated as end of string.
      `replaceCount` - the number of times to replace, -1 for replace all.
    Returns:
      `this` instance.
    Throws:
      `IndexOutOfBoundsException` - if start index is invalid.

  - ### replaceAll

    public StrBuilder replaceAll(char search, char replace)
    Deprecated.
    Replaces the search character with the replace character throughout the builder.
    Parameters:
      `search` - the search character.
      `replace` - the replace character.
    Returns:
      `this` instance.

  - ### replaceAll

    public StrBuilder replaceAll(String searchStr, String replaceStr)
    Deprecated.
    Replaces the search string with the replace string throughout the builder.
    Parameters:
      `searchStr` - the search string, null causes no action to occur.
      `replaceStr` - the replace string, null is equivalent to an empty string.
    Returns:
      `this` instance.

  - ### replaceAll

    public StrBuilder replaceAll(StrMatcher matcher, String replaceStr)
    Deprecated.
    Replaces all matches within the builder with the replace string.

    Matchers can be used to perform advanced replace behavior. For example you could write a matcher to replace all occurrences where the character 'a' is followed by a number.

    Parameters:
      `matcher` - the matcher to use to find the deletion, null causes no action.
      `replaceStr` - the replace string, null is equivalent to an empty string.
    Returns:
      `this` instance.

  - ### replaceFirst

    public StrBuilder replaceFirst(char search, char replace)
    Deprecated.
    Replaces the first instance of the search character with the replace character in the builder.
    Parameters:
      `search` - the search character.
      `replace` - the replace character.
    Returns:
      `this` instance.

  - ### replaceFirst

    public StrBuilder replaceFirst(String searchStr, String replaceStr)
    Deprecated.
    Replaces the first instance of the search string with the replace string.
    Parameters:
      `searchStr` - the search string, null causes no action to occur.
      `replaceStr` - the replace string, null is equivalent to an empty string.
    Returns:
      `this` instance.

  - ### replaceFirst

    public StrBuilder replaceFirst(StrMatcher matcher, String replaceStr)
    Deprecated.
    Replaces the first match within the builder with the replace string.

    Matchers can be used to perform advanced replace behavior. For example you could write a matcher to replace where the character 'a' is followed by a number.

    Parameters:
      `matcher` - the matcher to use to find the deletion, null causes no action.
      `replaceStr` - the replace string, null is equivalent to an empty string.
    Returns:
      `this` instance.

  - ### reverse

    public StrBuilder reverse()
    Deprecated.
    Reverses the string builder placing each character in the opposite index.
    Returns:
      `this` instance.

  - ### rightString

    public String rightString(int length)
    Deprecated.
    Extracts the rightmost characters from the string builder without throwing an exception.

    This method extracts the right `length` characters from the builder. If this many characters are not available, the whole builder is returned. Thus the returned string may be shorter than the length requested.

    Parameters:
      `length` - the number of characters to extract, negative returns empty string.
    Returns:
      The new string.

  - ### setCharAt

    public StrBuilder setCharAt(int index, char ch)
    Deprecated.
    Sets the character at the specified index.
    Parameters:
      `index` - the index to set.
      `ch` - the new character.
    Returns:
      `this` instance.
    Throws:
      `IndexOutOfBoundsException` - if the index is invalid.
    See Also:
      - `charAt(int)`
      - `deleteCharAt(int)`

  - ### setLength

    public StrBuilder setLength(int length)
    Deprecated.
    Updates the length of the builder by either dropping the last characters or adding filler of Unicode zero.
    Parameters:
      `length` - the length to set to, must be zero or positive.
    Returns:
      `this` instance.
    Throws:
      `IndexOutOfBoundsException` - if the length is negative.

  - ### setNewLineText

    public StrBuilder setNewLineText(String newLine)
    Deprecated.
    Sets the text to be appended when `new line` is called.
    Parameters:
      `newLine` - the new line text, `null` means use the system default from `System.lineSeparator()`.
    Returns:
      `this` instance.

  - ### setNullText

    public StrBuilder setNullText(String nullText)
    Deprecated.
    Sets the text to be appended when null is added.
    Parameters:
      `nullText` - the null text, null means no append.
    Returns:
      `this` instance.

  - ### size

    public int size()
    Deprecated.
    Gets the length of the string builder.

    This method is the same as `length()` and is provided to match the API of Collections.

    Returns:
      The length.

  - ### startsWith

    public boolean startsWith(String str)
    Deprecated.
    Checks whether this builder starts with the specified string.

    Note that this method handles null input quietly, unlike String.

    Parameters:
      `str` - the string to search for, null returns false.
    Returns:
      true if the builder starts with the string.

  - ### subSequence

    public CharSequence subSequence(int startIndex, int endIndex)
    Deprecated.
    Specified by:
      `subSequence` in interface `CharSequence`

  - ### substring

    public String substring(int start)
    Deprecated.
    Extracts a portion of this string builder as a string.
    Parameters:
      `start` - the start index, inclusive, must be valid.
    Returns:
      The new string.
    Throws:
      `IndexOutOfBoundsException` - if the index is invalid.

  - ### substring

    public String substring(int startIndex, int endIndex)
    Deprecated.
    Extracts a portion of this string builder as a string.

    Note: This method treats an endIndex greater than the length of the builder as equal to the length of the builder, and continues without error, unlike StringBuffer or String.

    Parameters:
      `startIndex` - the start index, inclusive, must be valid.
      `endIndex` - the end index, exclusive, must be valid except that if too large it is treated as end of string.
    Returns:
      The new string.
    Throws:
      `IndexOutOfBoundsException` - if the index is invalid.

  - ### toCharArray

    public char[] toCharArray()
    Deprecated.
    Copies the builder's character array into a new character array.
    Returns:
      a new array that represents the contents of the builder.

  - ### toCharArray

    public char[] toCharArray(int startIndex, int endIndex)
    Deprecated.
    Copies part of the builder's character array into a new character array.
    Parameters:
      `startIndex` - the start index, inclusive, must be valid.
      `endIndex` - the end index, exclusive, must be valid except that if too large it is treated as end of string.
    Returns:
      a new array that holds part of the contents of the builder.
    Throws:
      `IndexOutOfBoundsException` - if startIndex is invalid, or if endIndex is invalid (but endIndex greater than size is valid).

  - ### toString

    public String toString()
    Deprecated.
    Gets a String version of the string builder, creating a new instance each time the method is called.

    Note that unlike StringBuffer, the string version returned is independent of the string builder.

    Specified by:
      `toString` in interface `CharSequence`
    Overrides:
      `toString` in class `Object`
    Returns:
      The builder as a String.

  - ### toStringBuffer

    public StringBuffer toStringBuffer()
    Deprecated.
    Gets a StringBuffer version of the string builder, creating a new instance each time the method is called.
    Returns:
      The builder as a StringBuffer.

  - ### toStringBuilder

    public StringBuilder toStringBuilder()
    Deprecated.
    Gets a StringBuilder version of the string builder, creating a new instance each time the method is called.
    Returns:
      The builder as a StringBuilder.

  - ### trim

    public StrBuilder trim()
    Deprecated.
    Trims the builder by removing characters less than or equal to a space from the beginning and end.
    Returns:
      `this` instance.

  - ### validateIndex

    protected void validateIndex(int index)
    Deprecated.
    Validates parameters defining a single index in the builder.
    Parameters:
      `index` - the index, must be valid.
    Throws:
      `IndexOutOfBoundsException` - if the index is invalid.

  - ### validateRange

    protected int validateRange(int startIndex, int endIndex)
    Deprecated.
    Validates parameters defining a range of the builder.
    Parameters:
      `startIndex` - the start index, inclusive, must be valid.
      `endIndex` - the end index, exclusive, must be valid except that if too large it is treated as end of string.
    Returns:
      The new string.
    Throws:
      `IndexOutOfBoundsException` - if the index is invalid.